## qmmp 2.2.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18.0 FATAL_ERROR)
project(qmmp)

#freebsd support
if(${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
    include_directories(SYSTEM /usr/local/include)
    link_directories(AFTER /usr/local/lib)
    set(CMAKE_REQUIRED_INCLUDES ${CMAKE_REQUIRED_INCLUDES} /usr/local/include)
endif()

#macports support
if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
    set(CMAKE_REQUIRED_INCLUDES ${CMAKE_REQUIRED_INCLUDES} /opt/local/include)
endif()

IF(POLICY CMP0071)
  cmake_policy(SET CMP0071 NEW)
ENDIF()

if(POLICY CMP0063)
    cmake_policy(SET CMP0063 NEW)
endif()

#Qt6 modules
set(CMAKE_PREFIX_PATH ${CMAKE_PREFIX_PATH} /home/user/qt6)

#installation paths
include(GNUInstallDirs)
include(FindPkgConfig)

#extract version from qmmp.h
file(STRINGS "${CMAKE_CURRENT_SOURCE_DIR}/src/qmmp/qmmp.h"
     QMMP_VERSION_DATA REGEX "^#define[ \t]+QMMP_VERSION_[A-Z]+[ \t]+[0-9]+.*$")

if(QMMP_VERSION_DATA)
    foreach(item IN ITEMS MAJOR MINOR PATCH STABLE)
        string(REGEX REPLACE ".*#define[ \t]+QMMP_VERSION_${item}[ \t]+([0-9]+).*"
        "\\1" QMMP_VERSION_${item} ${QMMP_VERSION_DATA})
    endforeach(item IN ITEMS MAJOR MINOR PATCH)
   
    set(QMMP_VERSION "${QMMP_VERSION_MAJOR}.${QMMP_VERSION_MINOR}.${QMMP_VERSION_PATCH}")
    set(QMMP_SOVERSION "${QMMP_VERSION_MAJOR}")
   
    if(QMMP_VERSION_STABLE)
       message(STATUS "Qmmp API version: ${QMMP_VERSION} (stable)")
    else(QMMP_VERSION_STABLE)
       message(STATUS "Qmmp API version: ${QMMP_VERSION} (development)")
    endif(QMMP_VERSION_STABLE)
else(QMMP_VERSION_DATA)
    message(FATAL_ERROR "invalid header")
endif(QMMP_VERSION_DATA)

configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
  IMMEDIATE @ONLY)

add_custom_target(uninstall
  "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_C_VISIBILITY_PRESET hidden)
set(CMAKE_CXX_VISIBILITY_PRESET hidden)
set(CMAKE_VISIBILITY_INLINES_HIDDEN 1)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)

add_definitions(-DQT_DISABLE_DEPRECATED_BEFORE=0x060200 -DQT_DEPRECATED_WARNINGS -DQT_MESSAGELOGCONTEXT)
add_compile_options(-Wall -Wextra)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/src) #libqmmp & libqmmpui

find_package(Qt6 6.2 CONFIG REQUIRED COMPONENTS Widgets LinguistTools Network)
find_package(Qt6 6.2 CONFIG OPTIONAL_COMPONENTS DBus OpenGLWidgets Sql Multimedia)

get_target_property(QT_LRELEASE_EXECUTABLE Qt6::lrelease IMPORTED_LOCATION)

if(QT_LRELEASE_EXECUTABLE)
    message(STATUS "Found lrelease executable: " ${QT_LRELEASE_EXECUTABLE})
else(QT_LRELEASE_EXECUTABLE)
    message(FATAL_ERROR "Could NOT find lrelease executable")
endif(QT_LRELEASE_EXECUTABLE)

message(STATUS "Generating translations ...")

if(SVN_VERSION)
    execute_process(COMMAND find ${CMAKE_CURRENT_SOURCE_DIR} -name *.ts COMMAND xargs ${QT_LRELEASE_EXECUTABLE} -silent -nounfinished)
else(SVN_VERSION)
    execute_process(COMMAND find ${CMAKE_CURRENT_SOURCE_DIR} -name *.ts COMMAND xargs ${QT_LRELEASE_EXECUTABLE} -silent)
endif(SVN_VERSION)

set(PLUGIN_DIR "${CMAKE_INSTALL_LIBDIR}/qmmp-${QMMP_VERSION_MAJOR}.${QMMP_VERSION_MINOR}" CACHE STRING "plugin path")
set(USE_SKINNED TRUE CACHE BOOL "enable/disable standard skinned user interface")
set(USE_DIR_ASSOC TRUE CACHE BOOL "enable/disable inode/directory mime type association")
#set(APP_NAME_SUFFIX "-1")

get_target_property(QtGui_enabled_features Qt6::Gui QT_ENABLED_PUBLIC_FEATURES)
if("xcb" IN_LIST QtGui_enabled_features)
    pkg_search_module(X11 x11 IMPORTED_TARGET)
    set(XCB_ENABLED YES)
    add_definitions(-DQMMP_WS_X11)
endif()

if(X11_FOUND OR NOT XCB_ENABLED)
    set(SKINNED_AVAILABLE YES)
endif()

add_subdirectory(src/qmmp)
add_subdirectory(src/qmmpui)
add_subdirectory(src/plugins)
add_subdirectory(src/app)
add_subdirectory(doc)

if(MAD_FOUND)
    set(MPEG_DECODERS "MAD")
endif(MAD_FOUND)

if(MPG123_FOUND)
    set(MPEG_DECODERS ${MPEG_DECODERS} "mpg123")
endif(MPG123_FOUND)

macro(PRINT_SUMMARY str USE FOUND)
    if(${USE} AND ${FOUND})
        message("${str}enabled")
    else(${USE} AND ${FOUND})
        message("${str}disabled")
    endif(${USE} AND ${FOUND})
endmacro(PRINT_SUMMARY)

if(UNIX)
    add_custom_target (distclean @echo cleaning for source distribution)

   add_custom_command(
    COMMENT "distribution clean"
    COMMAND make
    ARGS -C ${CMAKE_CURRENT_BINARY_DIR} clean
    COMMAND find
    ARGS ${CMAKE_CURRENT_BINARY_DIR} -name "CMakeCache.txt" | xargs rm -rf
    COMMAND find
    ARGS ${CMAKE_CURRENT_BINARY_DIR} -name "CMakeFiles" | xargs rm -rf
    COMMAND find
    ARGS ${CMAKE_CURRENT_BINARY_DIR} -name "Makefile" | xargs rm -rf
    COMMAND find
    ARGS ${CMAKE_CURRENT_BINARY_DIR} -name \"*.cmake\" | xargs rm -rf
    COMMAND find
    ARGS ${CMAKE_CURRENT_SOURCE_DIR} -name "*.qm" | xargs rm -rf
    COMMAND find
    ARGS ${CMAKE_CURRENT_BINARY_DIR} -name "*.pc" | xargs rm -rf
    COMMAND find
    ARGS ${CMAKE_CURRENT_BINARY_DIR} -name "*.depends" | xargs rm -rf
    COMMAND find
    ARGS ${CMAKE_CURRENT_BINARY_DIR} -name "*.cxx_parameters" | xargs rm -rf
    COMMAND find
    ARGS ${CMAKE_CURRENT_BINARY_DIR} -name "moc_*.cpp" | xargs rm -rf
    COMMAND find
    ARGS ${CMAKE_CURRENT_BINARY_DIR} -name "qrc_*.cxx" | xargs rm -rf
    COMMAND find
    ARGS ${CMAKE_CURRENT_BINARY_DIR} -name "*_automoc.cpp" | xargs rm -rf
    COMMAND rm
    ARGS -rf ${CMAKE_CURRENT_BINARY_DIR}/install_manifest.txt
    COMMAND find
    ARGS ${CMAKE_CURRENT_BINARY_DIR} -name *_automoc.dir | xargs rm -rf
    COMMAND rm
    ARGS -rf ${CMAKE_CURRENT_BINARY_DIR}/doc/html .qt config.tests
    TARGET  distclean
)
endif(UNIX)


message("")
message("Transports:")
PRINT_SUMMARY ("HTTP support .........................." USE_CURL CURL_FOUND)
PRINT_SUMMARY ("MMS support ..........................." USE_MMS MMS_FOUND)

message("")
message("Input Plugins:")
PRINT_SUMMARY ("MPEG support .........................." 1 MAD_FOUND OR MPG123_FOUND)
PRINT_SUMMARY ("FLAC support .........................." USE_FLAC FLAC_FOUND)
PRINT_SUMMARY ("Ogg Vorbis support ...................." USE_VORBIS VORBIS_FOUND)
PRINT_SUMMARY ("Musepack support ......................" USE_MPC MPC_FOUND)
PRINT_SUMMARY ("MOD support ..........................." USE_XMP XMP_FOUND)
PRINT_SUMMARY ("Wave support .........................." USE_SNDFILE SNDFILE_FOUND)
PRINT_SUMMARY ("WavPack support ......................." USE_WAVPACK WAVPACK_FOUND)
PRINT_SUMMARY ("FFmpeg support ........................" USE_FFMPEG FFMPEG_FOUND)
PRINT_SUMMARY ("AAC support ..........................." USE_AAC FAAD_FOUND)
PRINT_SUMMARY ("CUE sheet support ....................." USE_CUE 1)
PRINT_SUMMARY ("Mplayer support ......................." USE_MPLAYER 1)
PRINT_SUMMARY ("CD Audio support ......................" USE_CDA CDIO_FOUND)
PRINT_SUMMARY ("Midi support .........................." USE_MIDI WILDMIDI_FOUND)
PRINT_SUMMARY ("Game music support ...................." USE_GME GME_FOUND)
PRINT_SUMMARY ("Ogg Opus support ......................" USE_OPUS OPUS_FOUND)
PRINT_SUMMARY ("SID support ..........................." USE_SID SIDPLAYFP_FOUND)
PRINT_SUMMARY ("Archive support ......................." USE_ARCHIVE LIBARCHIVE_FOUND)

message("")
message("Output Plugins:")
PRINT_SUMMARY ("ALSA support .........................." USE_ALSA ALSA_FOUND)
PRINT_SUMMARY ("OSS support ..........................." USE_OSS 1)
PRINT_SUMMARY ("OSS4 support .........................." USE_OSS4 OSS4_FOUND)
PRINT_SUMMARY ("JACK support .........................." USE_JACK JACK_FOUND)
PRINT_SUMMARY ("PulseAudio support ...................." USE_PULSE PULSE_FOUND)
PRINT_SUMMARY ("PipeWire support ......................" USE_PIPEWIRE PIPEWIRE_FOUND)
PRINT_SUMMARY ("Null output support ..................." USE_NULL 1)
PRINT_SUMMARY ("Waveout support (Windows) ............." USE_WAVEOUT WINDOWS_H_FOUND)
PRINT_SUMMARY ("DirectSound support (Windows) ........." USE_DSOUND DSOUND_H_FOUND)
PRINT_SUMMARY ("WASAPI support (Windows) .............." USE_WASAPI WASAPI_FOUND)
PRINT_SUMMARY ("Qt Multimedia support ................." USE_QTMULTIMEDIA Qt6Multimedia_FOUND)
PRINT_SUMMARY ("Icecast support ......................." USE_SHOUT SHOUT_FOUND)

message("")
message("Effect Plugins:")
PRINT_SUMMARY ("SoX Resampler ........................." USE_SOXR SOXR_FOUND)
PRINT_SUMMARY ("BS2B Plugin ..........................." USE_BS2B BS2B_FOUND)
PRINT_SUMMARY ("LADSPA Host ..........................." USE_LADSPA 1)
PRINT_SUMMARY ("Crossfade ............................." USE_CROSSFADE 1)
PRINT_SUMMARY ("Extra Stereo .........................." USE_STEREO 1)
PRINT_SUMMARY ("File Writer ..........................." USE_FILEWRITER VORBISENC_FOUND)
PRINT_SUMMARY ("Mono to Stereo Converter .............." USE_MONOTOSTEREO 1)

message("")
message("Visual Plugins:")
PRINT_SUMMARY ("Analyzer .............................." USE_ANALYZER 1)
PRINT_SUMMARY ("ProjectM .............................." USE_PROJECTM PROJECTM_FOUND)

message("")
message("General Plugins:")
PRINT_SUMMARY ("MPRIS support ........................." USE_MPRIS Qt6DBus_FOUND)
PRINT_SUMMARY ("Scrobbler ............................." USE_SCROBBLER 1)
PRINT_SUMMARY ("ListenBrainz .........................." USE_LISTENBRAINZ 1)
PRINT_SUMMARY ("Tray support .........................." USE_STATICON 1)
PRINT_SUMMARY ("Notifier support ......................" USE_NOTIFIER 1)
PRINT_SUMMARY ("Lyrics support ........................" USE_LYRICS 1)
PRINT_SUMMARY ("UDisks support ......,................." USE_UDISKS Qt6DBus_FOUND)
PRINT_SUMMARY ("Global hotkey support ................." USE_HOTKEY XCB_FOUND)
PRINT_SUMMARY ("GNOME/Cinnamon hotkey support ........." USE_GNOMEHOTKEY Qt6DBus_FOUND)
PRINT_SUMMARY ("File operations ......................." USE_FILEOPS 1)
PRINT_SUMMARY ("Cover manager ........................." USE_COVER 1)
PRINT_SUMMARY ("KDE notifications support ............." USE_KDENOTIFY Qt6DBus_FOUND)
PRINT_SUMMARY ("Audio converter ......................." USE_CONVERTER TAGLIB_FOUND)
PRINT_SUMMARY ("ReplayGain Scanner ...................." USE_RGSCAN TAGLIB_FOUND)
PRINT_SUMMARY ("Stream browser ........................" USE_SB 1)
PRINT_SUMMARY ("Track change .........................." USE_TRACKCHANGE 1)
PRINT_SUMMARY ("Copy/Paste ............................" USE_COPYPASTE 1)
PRINT_SUMMARY ("History plugin ........................" USE_HISTORY Qt6Sql_FOUND)
PRINT_SUMMARY ("Sleep mode inhibition plugin .........." USE_SLEEPINHIBITOR Qt6DBus_FOUND)
PRINT_SUMMARY ("Media library plugin .................." USE_LIBRARY Qt6Sql_FOUND)
PRINT_SUMMARY ("Taskbar plugin (Windows) .............." USE_TASKBAR WIN32)
PRINT_SUMMARY ("Removable device detection (Windows) .." USE_RDETECT WIN32)

message("")
message("File Dialogs:")
PRINT_SUMMARY ("QMMP File Dialog ......................" USE_QMMP_DIALOG 1)
PRINT_SUMMARY ("Two-panel File File Dialog ............" USE_TWO_PANEL_DIALOG 1)

message("")
message("User Interfaces:")
PRINT_SUMMARY ("Skinned user interface ................" USE_SKINNED SKINNED_AVAILABLE)
PRINT_SUMMARY ("Simple user interface (QSUI) .........." USE_QSUI 1)

message("")
message("Advanced:")
PRINT_SUMMARY ("Automatic charset detection ..........." USE_ENCA ENCA_FOUND)
PRINT_SUMMARY ("MPEG plugin with LibRCD support ......." USE_LIBRCD LIBRCD_FOUND)
PRINT_SUMMARY ("CD Audio plugin with CDDB support ....." USE_LIBCDDB CDDB_FOUND)
PRINT_SUMMARY ("Directory association ................." USE_DIR_ASSOC 1)
PRINT_SUMMARY ("Set RPATH in installed binaries ......." CMAKE_INSTALL_RPATH_USE_LINK_PATH 1)
if(MPEG_DECODERS)
    message   ("MPEG decoders ........................." "${MPEG_DECODERS}")
endif(MPEG_DECODERS)

message("")

=== src/plugins/Transports/CMakeLists.txt ===
set(USE_CURL TRUE CACHE BOOL "enable/disable curl-based http plugin")
set(USE_MMS TRUE CACHE BOOL "enable/disable mms plugin")

if(USE_CURL)
    add_subdirectory(http)
endif(USE_CURL)

if(USE_MMS)
    add_subdirectory(mms)
endif(USE_MMS)

=== src/plugins/Visual/CMakeLists.txt ===
set(USE_ANALYZER TRUE CACHE BOOL "enable/disable analyzer plugin")
set(USE_PROJECTM TRUE CACHE BOOL "enable/disable projectm plugin")

if(USE_ANALYZER)
    add_subdirectory(analyzer)
endif(USE_ANALYZER)

if(USE_PROJECTM)
    add_subdirectory(projectm)
endif(USE_PROJECTM)

=== src/plugins/Effect/bs2b/CMakeLists.txt ===
project(libbs2b)

set(libbs2b_SRCS
    bs2bplugin.cpp
    bs2bsettingsdialog.cpp
    effectbs2bfactory.cpp
    bs2bsettingsdialog.ui
    translations/translations.qrc
)

pkg_search_module(BS2B libbs2b>=3.0.0 IMPORTED_TARGET)

# Don't forget to include output directory, otherwise
# the UI file won't be wrapped!
include_directories(${CMAKE_CURRENT_BINARY_DIR})

if(BS2B_FOUND)
    add_library(bs2b MODULE ${libbs2b_SRCS})
    target_link_libraries(bs2b PRIVATE Qt6::Widgets libqmmp PkgConfig::BS2B)
    install(TARGETS bs2b DESTINATION ${PLUGIN_DIR}/Effect)
endif(BS2B_FOUND)

=== src/plugins/General/listenbrainz/CMakeLists.txt ===
project(liblistenbrainz)

SET(liblistenbrainz_SRCS
    listenbrainzsettingsdialog.cpp
    listenbrainzfactory.cpp
    payloadcache.cpp
    listenbrainz.cpp
    listenbrainzsettingsdialog.ui
    translations/translations.qrc
)

# Don't forget to include output directory, otherwise
# the UI file won't be wrapped!
include_directories(${CMAKE_CURRENT_BINARY_DIR})

add_library(listenbrainz MODULE ${liblistenbrainz_SRCS})
target_link_libraries(listenbrainz PRIVATE Qt6::Widgets Qt6::Network libqmmpui libqmmp)
install(TARGETS listenbrainz DESTINATION ${PLUGIN_DIR}/General)

=== src/plugins/General/rgscan/CMakeLists.txt ===
project(librgscan)

set(librgscan_SRCS
    rgscanfactory.cpp
    rgscanhelper.cpp
    rgscandialog.cpp
    rgscanner.cpp
    gain_analysis.c
    rgscandialog.ui
    translations/translations.qrc
)

# Don't forget to include output directory, otherwise
# the UI file won't be wrapped!
include_directories(${CMAKE_CURRENT_BINARY_DIR})

add_library(rgscan MODULE ${librgscan_SRCS} ${librgscan_UIS_H})
target_link_libraries(rgscan PRIVATE Qt6::Widgets libqmmpui libqmmp PkgConfig::TAGLIB)
install(TARGETS rgscan DESTINATION ${PLUGIN_DIR}/General)

=== src/plugins/Input/aac/CMakeLists.txt ===
project(libaac)

# libfaad
pkg_search_module(FAAD faad2>=2.9.2 IMPORTED_TARGET)

set(libaac_SRCS
  decoder_aac.cpp
  decoderaacfactory.cpp
  aacfile.cpp
  translations/translations.qrc
)

# Don't forget to include output directory, otherwise
# the UI file won't be wrapped!
include_directories(${CMAKE_CURRENT_BINARY_DIR})

if(FAAD_FOUND)
    add_library(aac MODULE ${libaac_SRCS} ${libaac_RCC_SRCS})
    target_link_libraries(aac PRIVATE Qt6::Widgets libqmmp PkgConfig::FAAD PkgConfig::TAGLIB)
    install(TARGETS aac DESTINATION ${PLUGIN_DIR}/Input)
endif(FAAD_FOUND)

=== src/plugins/Output/jack/CMakeLists.txt ===
project(libjack)

include(CheckCXXSourceCompiles)

include_directories(${CMAKE_CURRENT_BINARY_DIR})

# libjack and libsoxr
pkg_check_modules(JACK jack>=1.9.8 soxr IMPORTED_TARGET)

if(NOT JACK_FOUND)
    pkg_check_modules(JACK jack>=0.122.0 soxr IMPORTED_TARGET)
endif(NOT JACK_FOUND)

set(libjack_SRCS
  outputjackfactory.cpp
  outputjack.cpp
  bio2jack.c
  translations/translations.qrc
)

if(JACK_FOUND)
    add_library(jack MODULE ${libjack_SRCS})
    set_target_properties(jack PROPERTIES
                               COMPILE_FLAGS -pthread
                               LINK_FLAGS -pthread
    )
    target_link_libraries(jack PRIVATE Qt6::Widgets libqmmp PkgConfig::JACK)
    install(TARGETS jack DESTINATION ${PLUGIN_DIR}/Output)
endif(JACK_FOUND)

=== src/plugins/Visual/projectm/CMakeLists.txt ===
project(libprojectm)

# projectM
if(QT_FEATURE_opengl)
    message(STATUS "Found desktop OpenGL implementation")
    # projectM 4.0
    find_package(projectM4 COMPONENTS Playlist)
    if(projectM4_FOUND)
        add_definitions(-DPROJECTM_4)
        set(PROJECTM_FOUND TRUE CACHE INTERNAL "projectm")
        set(PROJECTM_PRESET_PATH ${CMAKE_INSTALL_DATADIR}/presets CACHE STRING "projectM preset search path")
        set(PROJECTM_TEXTURE_PATH ${CMAKE_INSTALL_DATADIR}/textures CACHE STRING "projectM texture search path")
        set(libprojectm_DEFINES ${libprojectm_DEFINES}
           PROJECTM_PRESET_PATH=\"${PROJECTM_PRESET_PATH}\"
           PROJECTM_TEXTURE_PATH=\"${PROJECTM_TEXTURE_PATH}\"
        )
        message(STATUS "Found projectM 4.x")
    else(projectM4_FOUND)
        # projectM 2.x/3.x 
        pkg_search_module(PROJECTM libprojectM>=2.0.0 IMPORTED_TARGET)
        if(PROJECTM_FOUND)
           find_file(PROJECTM_CONFIG config.inp
                     PATHS "/usr/share/projectM/" "/usr/local/share/projectM/")
           if(PROJECTM_VERSION VERSION_GREATER_EQUAL 3.1.0)
               ADD_DEFINITIONS(-DPROJECTM_31)
               MESSAGE(STATUS "Found projectM 3.x")
           else()
               MESSAGE(STATUS "Found projectM 2.x")
           endif()
        endif(PROJECTM_FOUND)
     endif(projectM4_FOUND)
else(QT_FEATURE_opengl)
    message(WARNING "Unsuppoted OpenGL implementation, projectM disabled")
endif(QT_FEATURE_opengl)

if(PROJECTM_CONFIG)
    set(libprojectm_DEFINES ${libprojectm_DEFINES} PROJECTM_CONFIG=\"${PROJECTM_CONFIG}\")
    message(STATUS "Found projectM configuration: ${PROJECTM_CONFIG}")
endif(PROJECTM_CONFIG)

set(libprojectm_SRCS
    projectmplugin.cpp
    visualprojectmfactory.cpp
    translations/translations.qrc
)

if(projectM4_FOUND)
    set(libprojectm_SRCS ${libprojectm_SRCS} projectm4widget.cpp)
else(projectM4_FOUND)
    set(libprojectm_SRCS ${libprojectm_SRCS} projectmwidget.cpp projectmwrapper.cpp)
endif(projectM4_FOUND)

# Don't forget to include output directory, otherwise
# the UI file won't be wrapped!
include_directories(${CMAKE_CURRENT_BINARY_DIR})
if(PROJECTM_FOUND)
    add_library(projectm MODULE ${libprojectm_SRCS})
  
    if(projectM4_FOUND)
        target_link_libraries(projectm PRIVATE Qt6::OpenGLWidgets libqmmp libprojectM::playlist)
    else(projectM4_FOUND)
        target_compile_definitions(projectm PRIVATE ${libprojectm_DEFINES})
        target_link_libraries(projectm PRIVATE Qt6::OpenGLWidgets libqmmp PkgConfig::PROJECTM -lGL)
    endif(projectM4_FOUND)
    install(TARGETS projectm DESTINATION ${PLUGIN_DIR}/Visual)
endif(PROJECTM_FOUND)

=== debian/changelog ===
qmmp (2.2.3-1) unstable; urgency=medium

  * Acknowledging NMU
  * New upstream version 2.2.3
    + Dropped 0001-qmmp.appdata.xml-Use-rDNS-identifier.patch
      (merged upstream)
    + Refreshed 0002-Fix-taglib-2.x-compatibility.patch
  * Updated d/copyright

 -- Harald Dunkel <harri@afaics.de>  Sat, 25 Jan 2025 11:35:32 +0100

=== debian/control ===
Source: qmmp
Section: sound
Priority: optional
Maintainer: Matteo Cypriani <mcy@lm7.fr>
Uploaders: Harald Dunkel <harri@afaics.de>
Build-Depends: debhelper-compat (= 13),
  cmake,
  libarchive-dev,
  libasound2-dev [linux-any],
  libavcodec-dev,
  libavformat-dev,
  libbs2b-dev,
  libcddb2-dev,
  libcdio-dev,
  libcdio-paranoia-dev,
  libcurl4-gnutls-dev,
  libenca-dev,
  libfaad-dev,
  libflac-dev,
  libgme-dev,
  libjack-jackd2-dev,
  libmad0-dev,
  libmms-dev,
  libmpcdec-dev,
  libogg-dev,
  libopus-dev,
  libopusfile-dev,
  libpipewire-0.3-dev,
  libprojectm-dev [!armel !armhf !hurd-any],
  libpulse-dev,
  libqt6opengl6-dev,
  librcd-dev,
  libshout-dev,
  libsidplayfp-dev,
  libsndfile1-dev,
  libsoxr-dev,
  libtag-dev,
  libvorbis-dev,
  libwavpack-dev,
  libwildmidi-dev,
  libx11-dev,
  libxmp-dev,
  oss4-dev [!linux-any],
  pkgconf,
  qt6-base-dev,
  qt6-multimedia-dev,
  qt6-tools-dev,
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: https://qmmp.ylsoftware.com/
Vcs-Git: https://salsa.debian.org/debian/qmmp.git
Vcs-Browser: https://salsa.debian.org/debian/qmmp

Package: qmmp
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: qmmp-plugin-projectm, ffmpeg, mplayer, unzip, udisks2 [linux-any]
Recommends: freepats
Replaces: libqmmp0 (<< 0.8), libqmmpui0 (<< 0.8), libqmmp-misc (<< 0.8)
Breaks: libqmmp0 (<< 0.8), libqmmpui0 (<< 0.8), libqmmp-misc (<< 0.8)
Description: feature-rich audio player with support of many formats
 Qmmp is feature-rich audio player with support of many formats.
 It is written in Qt.
 .
 Supported formats:
  - MPEG1 layer 2/3
  - Ogg Vorbis
  - Ogg Opus
  - Native FLAC, Ogg FLAC
  - Musepack
  - WavePack
  - tracker modules (mod, s3m, it, xm, etc)
  - ADTS AAC
  - CD Audio
  - WMA, Monkey's Audio (and other formats provided by FFmpeg library)
  - PCM WAVE (and other formats provided by libsndfile library)
  - midi
  - SID
  - chiptune formats (AY, GBS, GYM, HES, KSS, NSF, NSFE, SAP, SPC, VGM, VGZ,
    VTX)
 .
 DSP effects:
  - BS2B effect
  - sample rate converter
  - LADSPA effects
  - extra stereo
  - crossfade
 .
 Visual effects:
  - projectM visualization
  - spectrum analyzer
 .
 Audio output through:
  - ALSA
  - OSS
  - Pulse Audio
  - PipeWire
  - JACK
  - QTMultimedia
  - Icecast
 .
 Other features:
  - XMMS and Winamp 2.x skins support
  - alternative user interface based on standard widgets set
  - 10-band equalizer
  - MP3, Vorbis, AAC, AAC+ streams support
  - mms support
  - MPRIS
  - removable device detection (via UDisks)
  - video playback via Mplayer
  - lyrics
  - cover art support
  - CUE sheet support
  - embedded CUE support (for FLAC, WavPack and Monkey's Audio)
  - multiple playlists
  - automatic charset detection for cue files and ShoutCast metadata
  - playlist formats: m3u, pls, xspf
  - ReplayGain support
  - sending listening history to Last.fm, Libre.fm and ListenBrainz
  - CDDB support
  - audio converter
  - stream browser
  - audio formats converter
  - external programs execution on track change
  - ReplayGain scanner
  - archive reader (RAR and 7z)
  - audio recording
  - listening history
  - media library

Package: qmmp-plugin-projectm
Architecture: any-amd64 any-arm64 i386 any-mips64el any-mipsel any-ppc64el any-s390x any-alpha any-hppa any-ia64 kfreebsd-any any-m68k any-powerpc any-ppc64 any-riscv64 any-sh4 any-sparc64 any-x32
Depends: ${misc:Depends}, ${shlibs:Depends}, fonts-dejavu-core
Description: qmmp audio player -- projectM visualization plugin
 Qmmp is feature-rich audio player with support of many formats.
 It is written in Qt.
 .
 See 'qmmp' package for full description.
 .
 This package contains projectM visualization plugin for qmmp.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
#export DH_OPTIONS=-v

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

DEB_HOST_ARCH_OS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)

ifeq ($(DEB_HOST_ARCH_OS),linux)
	EXTRA_CMAKE_ARGS = -DUSE_OSS4:BOOL=FALSE
else
	EXTRA_CMAKE_ARGS = -DUSE_ALSA:BOOL=FALSE -DUSE_PIPEWIRE:BOOL=FALSE -DUSE_UDISKS:BOOL=FALSE
endif

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_INSTALL_PREFIX=/usr \
	  -DCMAKE_INSTALL_LIBDIR=lib/qmmp \
	  -DPLUGIN_DIR=lib/qmmp/plugins \
	  -DCMAKE_INSTALL_RPATH=/usr/lib/qmmp \
	  -DCMAKE_BUILD_WITH_INSTALL_RPATH:BOOL=TRUE \
	  $(EXTRA_CMAKE_ARGS)

override_dh_auto_build:
	dh_auto_build -- VERBOSE=1

override_dh_install:
ifneq (,$(filter-out armel armhf,$(DEB_HOST_ARCH)))
	dh_install -pqmmp-plugin-projectm
endif
	chmod +x debian/tmp/usr/share/qmmp/scripts/kwin.sh
	dh_install -Xprojectm

# Avoid a call to ldconfig in postinst & postrm (ldconfig is not needed since we
# only install private libraries)
override_dh_makeshlibs:
	dh_makeshlibs --noscripts

# dh_auto_clean doesn't call make distclean automatically from the CMake build
# directory, so we have to remove leftover .qm files manually
override_dh_auto_clean:
	find -name '*.qm' | xargs rm -fv
	dh_auto_clean

## qmmp 2.2.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -13,12 +13,16 @@
     set(CMAKE_REQUIRED_INCLUDES ${CMAKE_REQUIRED_INCLUDES} /opt/local/include)
 endif()
 
-IF(POLICY CMP0071)
+if(POLICY CMP0071)
   cmake_policy(SET CMP0071 NEW)
-ENDIF()
+endif()
 
 if(POLICY CMP0063)
     cmake_policy(SET CMP0063 NEW)
+endif()
+
+if(POLICY CMP0175)
+    cmake_policy(SET CMP0175 NEW)
 endif()
 
 #Qt6 modules
@@ -131,7 +135,8 @@
 if(UNIX)
     add_custom_target (distclean @echo cleaning for source distribution)
 
-   add_custom_command(
+    add_custom_command(
+    POST_BUILD
     COMMENT "distribution clean"
     COMMAND make
     ARGS -C ${CMAKE_CURRENT_BINARY_DIR} clean

=== src/plugins/Effect/filewriter/CMakeLists.txt ===
project(libfilewriter)

pkg_check_modules(VORBISENC vorbis ogg vorbisenc IMPORTED_TARGET)

set(libfilewriter_SRCS
    filewriterplugin.cpp
    filewritersettingsdialog.cpp
    effectfilewriterfactory.cpp
    filewritersettingsdialog.ui
    translations/translations.qrc
)

# Don't forget to include output directory, otherwise
# the UI file won't be wrapped!
include_directories(${CMAKE_CURRENT_BINARY_DIR})

if(VORBISENC_FOUND)
    add_library(filewriter MODULE ${libfilewriter_SRCS})
    target_link_libraries(filewriter PRIVATE Qt6::Widgets libqmmp libqmmpui PkgConfig::VORBISENC)
    install(TARGETS filewriter DESTINATION ${PLUGIN_DIR}/Effect)
endif(VORBISENC_FOUND)

=== src/plugins/General/covermanager/CMakeLists.txt ===
project(libcovermanager)

include_directories(${CMAKE_CURRENT_SOURCE_DIR})

set(libcovermanager_SRCS
    coverwidget.cpp
    covermanager.cpp
    covermanagerfactory.cpp
    translations/translations.qrc
    images/cm_images.qrc
)

# Don't forget to include output directory, otherwise
# the UI file won't be wrapped!
include_directories(${CMAKE_CURRENT_BINARY_DIR})

add_library(covermanager MODULE ${libcovermanager_SRCS})
target_link_libraries(covermanager PRIVATE Qt6::Widgets libqmmpui libqmmp)
install(TARGETS covermanager DESTINATION ${PLUGIN_DIR}/General)

=== src/plugins/General/fileops/CMakeLists.txt ===
project(libfileops)

set(libfileops_SRCS
    fileops.cpp
    fileopsfactory.cpp
    fileopssettingsdialog.cpp
    fileopssettingsdialog.ui
    translations/translations.qrc
)

# Don't forget to include output directory, otherwise
# the UI file won't be wrapped!
include_directories(${CMAKE_CURRENT_BINARY_DIR})

add_library(fileops MODULE ${libfileops_SRCS})
target_link_libraries(fileops PRIVATE Qt6::Widgets libqmmpui libqmmp)
install(TARGETS fileops DESTINATION ${PLUGIN_DIR}/General)

=== src/plugins/General/gnomehotkey/CMakeLists.txt ===
project(libgnomehotkey)

set(libgnomehotkey_SRCS
    gnomehotkeyfactory.cpp
    mediakeys.cpp
    translations/translations.qrc
)

# Don't forget to include output directory, otherwise
# the UI file won't be wrapped!
include_directories(${CMAKE_CURRENT_BINARY_DIR})

add_library(gnomehotkey MODULE ${libgnomehotkey_SRCS} ${libgnomehotkey_RCC_SRCS})
target_link_libraries(gnomehotkey PRIVATE Qt6::Widgets Qt6::DBus libqmmpui libqmmp)
install(TARGETS gnomehotkey DESTINATION ${PLUGIN_DIR}/General)

=== src/plugins/General/mpris/CMakeLists.txt ===
project(libmpris)

set(libmpris_SRCS
    mpris.cpp
    mprisfactory.cpp
    root2object.cpp
    player2object.cpp
    translations/translations.qrc
)

# Don't forget to include output directory, otherwise
# the UI file won't be wrapped!
include_directories(${CMAKE_CURRENT_BINARY_DIR})

add_library(mpris MODULE ${libmpris_SRCS})
target_link_libraries(mpris PRIVATE Qt6::Widgets Qt6::DBus libqmmpui libqmmp)
install(TARGETS mpris DESTINATION ${PLUGIN_DIR}/General)

=== src/plugins/General/streambrowser/CMakeLists.txt ===
project(libstreambrowser)

set(libstreambrowser_SRCS
    streambrowser.cpp
    streambrowserfactory.cpp
    streamwindow.cpp
    editstreamdialog.cpp
    streamwindow.ui
    editstreamdialog.ui
    translations/translations.qrc
)

# Don't forget to include output directory, otherwise
# the UI file won't be wrapped!
include_directories(${CMAKE_CURRENT_BINARY_DIR})

add_library(streambrowser MODULE ${libstreambrowser_SRCS})
target_link_libraries(streambrowser PRIVATE Qt6::Widgets Qt6::Network libqmmpui libqmmp)
install(TARGETS streambrowser DESTINATION ${PLUGIN_DIR}/General)

=== src/plugins/Output/pulseaudio/CMakeLists.txt ===
project(libpulseaudio)

# pulseaudio
pkg_check_modules(PULSE libpulse>=0.9.19 IMPORTED_TARGET)

set(libpulseaudio_SRCS
  outputpulseaudio.cpp
  outputpulseaudiofactory.cpp
  translations/translations.qrc
)

# Don't forget to include output directory, otherwise
# the UI file won't be wrapped!
include_directories(${CMAKE_CURRENT_BINARY_DIR})

if(PULSE_FOUND)
    add_library(pulseaudio MODULE ${libpulseaudio_SRCS})
    target_link_libraries(pulseaudio PRIVATE Qt6::Widgets libqmmp PkgConfig::PULSE)
    install(TARGETS pulseaudio DESTINATION ${PLUGIN_DIR}/Output)
endif(PULSE_FOUND)

=== debian/changelog ===
qmmp (2.2.4-1) unstable; urgency=medium

  [ Harald Dunkel ]
  * new upstream version 2.2.4
    + dropped obsolete 0002-Fix-taglib-2.x-compatibility.patch
  * debian/rules: delete debian/files for make clean

  [ Matteo Cypriani ]
  * Dropped obsolete lintian override
  * Bump Standards-Version to 4.7.2 (no changes needed)

 -- Harald Dunkel <harri@afaics.de>  Sun, 30 Mar 2025 12:35:14 +0200

=== debian/control ===
--- 
+++ 
@@ -45,7 +45,7 @@
   qt6-base-dev,
   qt6-multimedia-dev,
   qt6-tools-dev,
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: https://qmmp.ylsoftware.com/
 Vcs-Git: https://salsa.debian.org/debian/qmmp.git

=== debian/rules ===
--- 
+++ 
@@ -44,4 +44,5 @@
 # directory, so we have to remove leftover .qm files manually
 override_dh_auto_clean:
 	find -name '*.qm' | xargs rm -fv
+	rm -f debian/files
 	dh_auto_clean

## qmmp 2.2.5

=== src/plugins/General/trackchange/CMakeLists.txt ===
project(libtrackchange)

set(libtrackchange_SRCS
    trackchange.cpp
    trackchangefactory.cpp
    trackchangesettingsdialog.cpp
    trackchangesettingsdialog.ui
    translations/translations.qrc
)

# Don't forget to include output directory, otherwise
# the UI file won't be wrapped!
include_directories(${CMAKE_CURRENT_BINARY_DIR})

add_library(trackchange MODULE ${libtrackchange_SRCS})
target_link_libraries(trackchange PRIVATE Qt6::Widgets libqmmpui libqmmp)
install(TARGETS trackchange DESTINATION ${PLUGIN_DIR}/General)

=== debian/changelog ===
qmmp (2.2.5-0.1~mx23+1) mx; urgency=medium

  * New upstream version 2.2.5.

 -- Steven Pusser <stevep@mxlinux.org>  Wed, 30 Apr 2025 13:20:37 -0700

qmmp (2.2.4-1~mx23+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Fri, 18 Apr 2025 08:52:50 -0700

=== debian/control ===
Source: qmmp
Section: sound
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Matteo Cypriani <mcy@lm7.fr>
Uploaders: Harald Dunkel <harri@afaics.de>
Build-Depends: cmake,
               debhelper-compat (= 13),
               libarchive-dev,
               libasound2-dev [linux-any],
               libavcodec-dev,
               libavformat-dev,
               libbs2b-dev,
               libcddb2-dev,
               libcdio-dev,
               libcdio-paranoia-dev,
               libcurl4-gnutls-dev,
               libenca-dev,
               libfaad-dev,
               libflac-dev,
               libgme-dev,
               libjack-jackd2-dev,
               libmad0-dev,
               libmms-dev,
               libmpcdec-dev,
               libogg-dev,
               libopus-dev,
               libopusfile-dev,
               libpipewire-0.3-dev,
               libprojectm-dev [!armel !armhf !hurd-any],
               libpulse-dev,
               libqt6opengl6-dev,
               librcd-dev,
               libshout-dev,
               libsidplayfp-dev,
               libsndfile1-dev,
               libsoxr-dev,
               libtag-dev,
               libvorbis-dev,
               libwavpack-dev,
               libwildmidi-dev,
               libx11-dev,
               libxmp-dev,
               oss4-dev [!linux-any],
               pkgconf,
               qt6-base-dev,
               qt6-multimedia-dev,
               qt6-tools-dev
Standards-Version: 4.7.2
Rules-Requires-Root: no
Homepage: https://qmmp.ylsoftware.com/
Vcs-Git: https://salsa.debian.org/debian/qmmp.git
Vcs-Browser: https://salsa.debian.org/debian/qmmp

Package: qmmp
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: ffmpeg, mplayer, qmmp-plugin-projectm, udisks2 [linux-any], unzip
Recommends: freepats
Replaces: libqmmp-misc (<< 0.8), libqmmp0 (<< 0.8), libqmmpui0 (<< 0.8)
Breaks: libqmmp-misc (<< 0.8), libqmmp0 (<< 0.8), libqmmpui0 (<< 0.8)
Description: feature-rich audio player supporting many formats--Qt 6 version
 Qmmp is a feature-rich audio player with support of many formats.
 It is written in Qt. This is the Qt 6 version
 .
 Supported formats:
  - MPEG1 layer 2/3
  - Ogg Vorbis
  - Ogg Opus
  - Native FLAC, Ogg FLAC
  - Musepack
  - WavePack
  - tracker modules (mod, s3m, it, xm, etc)
  - ADTS AAC
  - CD Audio
  - WMA, Monkey's Audio (and other formats provided by FFmpeg library)
  - PCM WAVE (and other formats provided by libsndfile library)
  - midi
  - SID
  - chiptune formats (AY, GBS, GYM, HES, KSS, NSF, NSFE, SAP, SPC, VGM, VGZ,
    VTX)
 .
 DSP effects:
  - BS2B effect
  - sample rate converter
  - LADSPA effects
  - extra stereo
  - crossfade
 .
 Visual effects:
  - projectM visualization
  - spectrum analyzer
 .
 Audio output through:
  - ALSA
  - OSS
  - Pulse Audio
  - PipeWire
  - JACK
  - QTMultimedia
  - Icecast
 .
 Other features:
  - XMMS and Winamp 2.x skins support
  - alternative user interface based on standard widgets set
  - 10-band equalizer
  - MP3, Vorbis, AAC, AAC+ streams support
  - mms support
  - MPRIS
  - removable device detection (via UDisks)
  - video playback via Mplayer
  - lyrics
  - cover art support
  - CUE sheet support
  - embedded CUE support (for FLAC, WavPack and Monkey's Audio)
  - multiple playlists
  - automatic charset detection for cue files and ShoutCast metadata
  - playlist formats: m3u, pls, xspf
  - ReplayGain support
  - sending listening history to Last.fm, Libre.fm and ListenBrainz
  - CDDB support
  - audio converter
  - stream browser
  - audio formats converter
  - external programs execution on track change
  - ReplayGain scanner
  - archive reader (RAR and 7z)
  - audio recording
  - listening history
  - media library

Package: qmmp-plugin-projectm
Architecture: any-alpha any-amd64 any-arm64 any-hppa any-ia64 any-m68k any-mips64el any-mipsel any-powerpc any-ppc64 any-ppc64el any-riscv64 any-s390x any-sh4 any-sparc64 any-x32 kfreebsd-any i386
Depends: fonts-dejavu-core, ${misc:Depends}, ${shlibs:Depends}
Description: qmmp audio player -- projectM visualization plugin
 Qmmp is a feature-rich audio player with support of many formats.
 It is written in Qt.
 .
 See 'qmmp' package for full description.
 .
 This package contains the projectM visualization plugin for qmmp.

=== debian/rules ===
--- 
+++ 
@@ -46,3 +46,8 @@
 	find -name '*.qm' | xargs rm -fv
 	rm -f debian/files
 	dh_auto_clean
+
+# No dbgsym packages:
+override_dh_strip:
+	@echo "NO--THANKS ANYWAY--but not building dbgsym packages for MX Linux"
+	dh_strip --no-automatic-dbgsym

## qmmp 2.2.7

=== debian/changelog ===
qmmp (2.2.7-1) unstable; urgency=medium

  [ Harald Dunkel ]
  * new upstream version 2.2.7
    + upstream fixed build errors for QT 6.9 (Forky) in qmmp 2.2.4
      (Closes: #1097702)

  [ Matteo Cypriani ]
  * d/rules: Make kwin6.sh executable

 -- Matteo Cypriani <mcy@lm7.fr>  Sun, 17 Aug 2025 15:04:38 +0200

qmmp (2.2.5-1) unstable; urgency=medium

  * new upstream version 2.2.5

 -- Harald Dunkel <harri@afaics.de>  Mon, 28 Apr 2025 18:12:30 +0200
